sang1/DAweb/Controllers/Admin/QuanLyDonHangController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using DAweb.Models;
using System.IO;

namespace DAweb.Controllers.Admin
{
    public class QuanLyDonHangController : Controller
    {
        dbWebBanHangEntities db = new dbWebBanHangEntities();
        // GET: QuanLyDonHang
        [HttpGet]
        public ActionResult DanhSachHoaDon()
        {
            if (Request.Cookies["TaiKhoanAdmin"] == null || Request.Cookies["TaiKhoanAdmin"].ToString() == "")
            {
                return RedirectToAction("DangNhapAdmin", "Logon");
            }
            return View(db.tblHoaDons.ToList());
        }
        [HttpGet]
        public ActionResult CTHD(int MaHD)
        {
            if (Request.Cookies["TaiKhoanAdmin"] == null || Request.Cookies["TaiKhoanAdmin"].ToString() == "")
            {
                return RedirectToAction("DangNhapAdmin", "Logon");
            }
            List<tblCTHoaDon> cthd = db.tblCTHoaDons.Where(n=>n.MaHD==MaHD).ToList();
                 if(cthd==null)
                 {
                  Response.StatusCode = 404;
                 }
            ViewBag.IdDonHang = MaHD;
            return View(cthd);
        }
        [HttpPost]
        public ActionResult update(FormCollection f)
        {
            int MaHD = int.Parse(f["IDDonHang"]);
            tblHoaDon dh = db.tblHoaDons.First(m => m.MaHD == MaHD);
            if(dh==null)
            {
                Response.StatusCode = 404;
            }
            dh.TrangThai = "Đã xử Lý ";
            UpdateModel(dh);
            db.SaveChanges();
            return RedirectToAction("DanhSachHoaDon");
        }

        [HttpGet]
        public ActionResult ChinhSuaHoaDon(int MaHD)
        {
            if (Request.Cookies["TaiKhoanAdmin"] == null || Request.Cookies["TaiKhoanAdmin"].ToString() == "")
            {
                return RedirectToAction("DangNhapAdmin", "Logon");
            }
            // lấy ra đối tượng sách theo mã 
            tblHoaDon HD = db.tblHoaDons.SingleOrDefault(n => n.MaHD == MaHD);
            if (HD == null)
            {
                Response.StatusCode = 404;
            }

            return View(HD);
        }
        [HttpPost]
        [ValidateInput(false)]
        public ActionResult ChinhSuaHoaDon(tblHoaDon HD)
        {
            //Thêm vào cơ sở dữ liệu
            if (ModelState.IsValid)
            {
                //Thực hiện cập nhập trong model
                db.Entry(HD).State = System.Data.Entity.EntityState.Modified;
                db.SaveChanges();
                ViewBag.ThongBao = "Cập Nhập Dữ Liệu Thanh Thành Công ";
            }

            //Đưa dữ liệu vào dropdownlist
            return RedirectToAction("DanhSachHoaDon");
        }

        public int XoaCTHD(int MaHD)
        {      
            //Lấy ra đối tượng sách theo mã 
            tblCTHoaDon sp = db.tblCTHoaDons.SingleOrDefault(n=>n.MaHD== MaHD);
            return sp.MaSP;
        }
        //Xóa sản phẩm
        [HttpGet]
        public ActionResult XoaHD(int MaHD)
        {
            if (Request.Cookies["TaiKhoanAdmin"] == null || Request.Cookies["TaiKhoanAdmin"].ToString() == "")
            {
                return RedirectToAction("DangNhapAdmin", "Logon");
            }
            //Lấy ra đối tượng sách theo mã 
            tblHoaDon sp = db.tblHoaDons.SingleOrDefault(n => n.MaHD == MaHD);
            if (sp == null)
            {
                Response.StatusCode = 404;
                return null;
            }
            return View(sp);
        }
        [HttpPost, ActionName("XoaHD")]

        public ActionResult XacNhanXoa(int MaHD)
        {
            tblHoaDon hd = db.tblHoaDons.SingleOrDefault(n => n.MaHD == MaHD);
            if (hd == null)
            {
                Response.StatusCode = 404;
                return null;
            }
            List<tblCTHoaDon> cthd= db.tblCTHoaDons.Where(n => n.MaHD == MaHD).ToList();
                db.tblCTHoaDons.RemoveRange(cthd);
            db.tblHoaDons.Remove(hd);
            db.SaveChanges();
            return RedirectToAction("DanhSachHoaDon");
        }
    }
}

sang1/DAweb/Views/QuanLyDonHang/CTHD.cshtml
@model IEnumerable<DAweb.Models.tblCTHoaDon>

@{
    ViewBag.Title = "CTHD";
    Layout = "~/Views/Layout/AdminLayout.cshtml";
}

<h2>Chi Tiết Hóa Đơn</h2>

@using (Html.BeginForm("update", "QuanLyDonHang", FormMethod.Post, new { @enctype = "multipart/form-data" }))
{
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.MaHD)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.MaSP)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.SoLuong)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.DonGia)
        </th>
       
        <th>
            @Html.DisplayNameFor(model => model.TenSanPham)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.AnhSanPham)
        </th>
        <th></th>
    </tr>

@foreach (var item in Model)
{
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.MaHD)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.MaSP)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.SoLuong)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.DonGia)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.TenSanPham)
        </td>
        <td>
            <div><img src="@Url.Content("~/App_Themes/HinhAnhSanPham/" + item.AnhSanPham)" style="width:100px" /></div>
        </td>
      
       
    </tr>
} 
      
            <tr>
                <td class="btn btn-danger">
                    <input type="hidden" name="IDDonHang" value="@ViewBag.IdDonHang" />
                    <button type="submit" class="btn btn-danger">Đóng đơn hàng này</button>
                </td>
            </tr>  

     

</table>
}
<div>
    <a href="@Url.Action("DanhSachHoaDon")" class="btn btn-primary btn-lg btn-block">Trở Về </a>
</div>

sang1/DAweb/Views/QuanLyDonHang/DanhSachHoaDon.cshtml
@model IEnumerable<DAweb.Models.tblHoaDon>

@{
    ViewBag.Title = "DanhSachHoaDon";
    Layout = "~/Views/Layout/AdminLayout.cshtml";
}

<h2>Danh Sách Hóa Đơn </h2>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.MaHD)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.TenTaiKhoan)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.NgayMua)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.DiaChiGiaoHang)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.SDTGiaoHang)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.TongTien)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.TrangThai)
        </th>
        <th></th>
    </tr>
@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.MaHD)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.TenTaiKhoan)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.NgayMua)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.DiaChiGiaoHang)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.SDTGiaoHang)
        </td>
               <td>@String.Format("{0:0,0}", item.TongTien) VNĐ</td>
        
        <td>
            @Html.DisplayFor(modelItem => item.TrangThai)
        </td>
      
        <td><a class="btn btn-danger" href="@Url.Action("CTHD", new { @MaHD = item.MaHD  })"><i class="fa fa-pencil-square-o"></i>Xem</a></td>
        <td><a class="btn btn-danger" href="@Url.Action("XoaHD", new {  @MaHD = item.MaHD  })"><i class="glyphicon glyphicon-trash"></i>Xóa</a></td>

        
    </tr>
}
</table>

sang1/DAweb/Views/QuanLyDonHang/XoaHD.cshtml
@model DAweb.Models.tblHoaDon

@{
    ViewBag.Title = "XoaHD";
    Layout = "~/Views/Layout/AdminLayout.cshtml";
}

<h2>Xoá Hóa Đơn </h2>
<div>
   
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.MaHD)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.MaHD)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.TenTaiKhoan)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.TenTaiKhoan)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.NgayMua)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.NgayMua)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.DiaChiGiaoHang)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.DiaChiGiaoHang)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.SDTGiaoHang)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.SDTGiaoHang)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.TongTien)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.TongTien)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.TrangThai)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.TrangThai)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()
        <div class="form-actions no-color">
            <input type="submit" value="Xóa" class="btn btn-danger"  onclick="return confirm('Bạn có chắc muốn xóa Hóa Đơn Này Không');" /> 
                <a href="@Url.Action("DanhSachHoaDon")" class="btn btn-danger">Trở Về </a>
        </div>
    }
</div>